



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>eMMC基础技术3：eMMC总线token</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">eMMC基础技术3：eMMC总线token</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 08:05:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>1.前言</h1>
<p>本文主要介绍eMMC 总线协议相关的内容，主要包括：</p>
<p>（1）command token format</p>
<p>（2）response token format</p>
<p>（3）data packet format</p>
<p>（4）CRC token</p>
<p>（5）bus speed mode</p>
<h1>2. command token format</h1>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170330221559718" /></div>
<div>图 cmd token format</div>
<ul><li>总长度48bits;</li>
<li>固定以0开始，以1结束;</li>
<li>transmiter bit表示数据的传输方向，1代表从host to device;</li>
<li>通过CRC7保护，device 端在接收到CMD时同样会计算一个CRC值，如果与host发送的CRC不一致，则被认为是传输错误；</li></ul>
<div>详情请参考 eMMC基础技术3：eMMC command</div>
<h1>3. response token format</h1>
<div></p>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170330222617657" /></div>
<div>图 response token format</div>
<ul><li>有5种格式，使用哪种格式依赖于CMD，长度为48bits或136bits；</li>
<li>start bit 总是0,在没有数据传输的情况下，CMD 信号保持高电平，当 eMMC Device 将 Start Bit 发送到总线上时，Host 可以很方便检测到该信号，并开始接收 Response</li>
<li>transmitter bit代表传输方向，0表示device to host;</li>
<li>Content 为 Response 的具体内容，不同的 Command 会有不同的 Content</li>
<li>CRC7 是包含 Start Bit、Transmission Bit 和 Content 内容的 CRC 校验值</li>
<li>End Bit 为结束标志位，固定为"1"。</li></ul>
<div>
<h1>4. data packet format</h1>
<div>（1） 1bit sdr传输</div>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170330223408805" /></p>
<div>&nbsp; &nbsp; &nbsp;图 1bit bus sdr传输</div>
<div>start bit + data + crc + end bit</div>
<div>&nbsp;</div>
<div>1bit sdr只使用了DATA0数据线，对于1个block（block length=512BYTE）来讲，需要花费block length * 8 cycles</div>
<div>&nbsp;</div>
<div>（2）4bit sdr传输</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170330223825671" /></div>
<div>&nbsp; &nbsp; &nbsp; &nbsp;图 4bit bus sdr传输</div>
<div>对于1个block（block length=512BYTE）来讲，需要花费block length &nbsp;* 8 / 4 = block length *2 cycles</div>
<div>（3）8bit sdr传输</div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170330223858391" /></div>
<div>&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;图 8bit bus sdr传输</div>
<div>对于1个block（block length=512BYTE）来讲，对于1个block（block length=512BYTE）来讲，需要花费block length * 8 / 8 = block length cycles</div>
<div>&nbsp;</div>
<div>（4）4bit bus ddr传输</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170331101740790" /></div>
<div>图 4bit bus ddr传输</div>
<div>ddr传输时，上升沿和下降沿都会传输数据，对于1个block（block length=512BYTE）来讲，需要花费block lenght * 8 / 4 / 2 = block length cycles</div>
<div>&nbsp;</div>
<div>（5）8bit bus ddr传输</div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170331074406661" /></div>
<div>&nbsp;</div>
<div>图 8bit bus ddr传输</div>
<div>&nbsp;</div>
<div>ddr传输时，上升沿和下降沿都会传输数据，对于1个block（block length=512BYTE）来讲，需要花费block lenght * 8 / 8 / 2 = block length / 2 cycles</div>
<div>&nbsp;</div>
<div>在 DDR 模式下，Data Line 在时钟的上升沿和下降沿都会传输数据，其中上升沿传输数据的奇数字节 （Byte 1,3,5 ...），下降沿则传输数据的偶数字节（Byte 2,4,6 ...）。<br />此外，在 DDR 模式下，1 个 Data Line 上有两个相互交织的 CRC16，上升沿的 CRC 比特组成 odd CRC16，下降沿的 CRC 比特组成 even CRC16。</div>
<div>odd CRC16 用于校验该 Data Line 上所有上升沿比特组成的数据，even CRC16 则用于校验该 Data Line 上所有下降沿比特组成的数据</div>
<div>（6）8bit ddr for hs400&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20170331082046143" /></div>
<div>&nbsp;</div>
<div>图 8bit ddr for hs400</div>
<div>hs400 高电平或低电平用于传输数据，对于1个block（block length=512BYTE）来讲，需要花费block lenght * 8 / 8 / 2 = block length / 2 cycles</div>
<h1>5. CRC status token</h1>
<p>在写数据传输中，eMMC Device 接收到 Host 发送的一个 Data Block 后，会进行 CRC 校验</p>
<ul><li>如果校验失败，device则会在对应的 Data Line 上向host发送一个 Negative CRC status token (101)</li>
<li>如果校验成功，device则会在对应的 Data Line 上向host发送一个 Positive CRC status token (010)</li></ul>
<p>注:读数据时，Host 接收到 eMMC Device 发送的 Data Block 后，也会进行 CRC 校验，但是不管校验成功或者失败，都不会向 eMMC Device 发送 CRC Status Token</p>
<p>详细格式如下图所示：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1138116/201704/1138116-20170401172515367-852138357.png" /></p>
<p>图 DR52 Positive CRC status token</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1138116/201704/1138116-20170401172502805-1443990279.png" /></p>
<p>图 DDR52 Negative CRC status token</p>
<h1>6. 参考文档</h1>
<p>[1]<a href="http://www.wowotech.net/basic_tech/emmc_bus_protocol.html" rel="external nofollow noreferrer">http://www.wowotech.net/basic_tech/emmc_bus_protocol.html</a></p>
<p>[2]<a href="http://www.jedec.org/sites/default/files/docs/JESD84-B51.pdf" rel="external nofollow noreferrer">http://www.jedec.org/sites/default/files/docs/JESD84-B51.pdf</a></p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvoeo8x.html">4&period;修改更新源sources&period;list，提高软件下载安装速度（提供Kali 2&period;0 更新源）</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eokkkq.html">mongogogog</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q22dk3q.html">ionic 使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxx4lvq.html">Bzoj2007 &lbrack;Noi2010&rsqb;海拔</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1o0d08.html">POJ 1673 EXOCENTER OF A TRIANGLE&lpar;垂心&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r932nd0q.html">Java：多线程&amp;lt&semi;一&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m966gnn9.html">各个JSON技术的比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0r52wq.html">oracle 回收站</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgzymr8.html">2015-12-27 socket的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljmlx19.html">基于visual Studio2013解决C语言竞赛题之1060寻找回文数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kr7e09.html">Struts2更改配置文件struts&period;xml默认路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge54ne8.html">redis多数据库操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eydeze9.html">《通过C&num;学Proto&period;Actor模型》之Prpos</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wxl1nq.html">&lbrack;随笔&rsqb;&lbrack;胡思乱想&rsqb;&lbrack;唠叨&rsqb;&lbrack;web server&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1dwl49.html">python常用模块os和sys</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd4j2z9.html">React Refs</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o13018.html">charles4&period;2下载与破解方法以及配置https</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w2o5rq.html">iOS 新浪微博-5&period;2 首页微博列表&lowbar;转发微博&sol;工具栏</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r6y5z8.html">java was started but exit code &equals;-805306369</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvg1zr8.html">suffix word ard ar arian arium atic ation atory ator out ~3</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e45jem9.html">MySql笔记一：安装MySql</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jmky0q.html">NGUI使用图集的精灵换图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwdzwv9.html">java io系列09之 FileDescriptor总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9607ywj9.html">python 面向对象&lpar;四&rpar;反射</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1n25l9.html">java版微信公众号支付&lpar;H5调微信内置API&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96074139.html">Retrofit的通讯方式示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rp2268.html">js强制将页面放到最大</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rjl339.html">Groovy 设计模式 -- proxy &amp;amp&semi; delegate</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwd3zv9.html">S02-45 struts2 最新漏洞 学习记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv5pwk8.html">mvc EF框架中，加载外键对象序列化对象时报错 序列化类型为XX的对象时检测到循环引用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
